/*----- PROTECTED REGION ID(Omega_CN7.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Omega_CN7.cpp,v 1.1.1.1 2013-12-24 14:51:55 borghes Exp $";
//=============================================================================
//
// file :        Omega_CN7.cpp
//
// description : C++ source for the Omega_CN7 and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Omega_CN7 are implemented in this file.
//
// project :     OMEGA CN7 series temperature/process controller.
//
// $Author: borghes $
//
// $Revision: 1.1.1.1 $
// $Date: 2013-12-24 14:51:55 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/omegacn7x/src/Omega_CN7.cpp,v $
// $Log: Omega_CN7.cpp,v $
// Revision 1.1.1.1  2013-12-24 14:51:55  borghes
// OMEGA CN7x Device Server
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Omega_CN7.h>
#include <Omega_CN7Class.h>

/*----- PROTECTED REGION END -----*/


/**
 *	Omega_CN7 class description:
 *	OMEGA CN7200, CN7500, CN7600, CN7800 Series
 */

//================================================================
//
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//----------------------------------------------------------------
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//================================================================

namespace Omega_CN7_ns
{
	/*----- PROTECTED REGION ID(Omega_CN7::namespace_starting) ENABLED START -----*/

	//	static initializations

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::namespace_starting



//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::Omega_CN7()
 *	Description : Constructors for a Tango device
 *	              implementing the class Omega_CN7
 */
//--------------------------------------------------------
Omega_CN7::Omega_CN7(Tango::DeviceClass *cl, string &s)
 	: Tango::Device_4Impl(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Omega_CN7::constructor_1) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::constructor_1
}
//--------------------------------------------------------
Omega_CN7::Omega_CN7(Tango::DeviceClass *cl, const char *s)
 	: Tango::Device_4Impl(cl, s)
{
	/*----- PROTECTED REGION ID(Omega_CN7::constructor_2) ENABLED START -----*/
	init_device();

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::constructor_2
}
//--------------------------------------------------------
Omega_CN7::Omega_CN7(Tango::DeviceClass *cl, const char *s, const char *d)
 	: Tango::Device_4Impl(cl, s, d)
{
	/*----- PROTECTED REGION ID(Omega_CN7::constructor_3) ENABLED START -----*/
	init_device();

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::constructor_3
}


//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::delete_device()()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Omega_CN7::delete_device()
{
	/*----- PROTECTED REGION ID(Omega_CN7::delete_device) ENABLED START -----*/

	//	Delete device allocated objects
	close_connection(modbus_device);

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::delete_device
	delete[] attr_ParametersReadonly_read;
	delete[] attr_SetPoint_read;
	delete[] attr_Temp_Upper_Limit_read;
	delete[] attr_Temp_Lower_Limit_read;
	delete[] attr_SensorType_read;
	delete[] attr_Control_method_read;
	delete[] attr_Heating_Cooling_Control_read;
	delete[] attr_TemperatureValue_read;
	delete[] attr_Temperature_Unit_read;
	delete[] attr_Led_Status_read;
	
}


//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::init_device()
 *	Description : //	will be called at device initialization.
 */
//--------------------------------------------------------
void Omega_CN7::init_device()
{
	DEBUG_STREAM << "Omega_CN7::init_device() create device " << device_name << endl;

	/*----- PROTECTED REGION ID(Omega_CN7::init_device_before) ENABLED START -----*/

	//	Initialization before get_device_property() call
	modbus_device = NULL;

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::init_device_before
	
	//	Get the device properties (if any) from database
	get_device_property();
	
	attr_ParametersReadonly_read = new Tango::DevBoolean[1];
	attr_SetPoint_read = new Tango::DevDouble[1];
	attr_Temp_Upper_Limit_read = new Tango::DevDouble[1];
	attr_Temp_Lower_Limit_read = new Tango::DevDouble[1];
	attr_SensorType_read = new Tango::DevShort[1];
	attr_Control_method_read = new Tango::DevShort[1];
	attr_Heating_Cooling_Control_read = new Tango::DevShort[1];
	attr_TemperatureValue_read = new Tango::DevDouble[1];
	attr_Temperature_Unit_read = new Tango::DevShort[1];
	attr_Led_Status_read = new Tango::DevShort[1];
	
	/*----- PROTECTED REGION ID(Omega_CN7::init_device) ENABLED START -----*/

	//	Initialize device
	get_modbus_connection();

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::init_device
}



//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::get_device_property()
 *	Description : //	Add your own code to initialize
 */
//--------------------------------------------------------
void Omega_CN7::get_device_property()
{
	/*----- PROTECTED REGION ID(Omega_CN7::get_device_property_before) ENABLED START -----*/

	//	Initialize property data members

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("Modbus_devicename"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on Omega_CN7Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		Omega_CN7Class	*ds_class =
			(static_cast<Omega_CN7Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize Modbus_devicename from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  modbus_devicename;
		else {
			//	Try to initialize Modbus_devicename from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  modbus_devicename;
		}
		//	And try to extract Modbus_devicename value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  modbus_devicename;


	}
	/*----- PROTECTED REGION ID(Omega_CN7::get_device_property_after) ENABLED START -----*/

	//	Check device property data members init
        int ii=-1;

	try
	{
	  dev_prop[++ii] << modbus_devicename;
	  if (Tango::Util::instance()->_UseDb==true)
		get_db_device()->put_property(dev_prop);
	}
	catch(...)
	{
		cout << "UNABLE TO EXECUTE put_property(dev_prop)" << endl;
	}
	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::get_device_property_after

}

//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Omega_CN7::always_executed_hook()
{
	INFO_STREAM << "Omega_CN7::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::always_executed_hook) ENABLED START -----*/

	//	code always executed before all requests

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::always_executed_hook
}



//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::read_attr_hardware()
 *	Description : Hardware acquisition for attributes.
 */
//--------------------------------------------------------
void Omega_CN7::read_attr_hardware(vector<long> &attr_list)
{
	DEBUG_STREAM << "Omega_CN7::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::read_attr_hardware) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::read_attr_hardware

}


//--------------------------------------------------------
/**
 *	Read ParametersReadonly attribute
 *	Description: Enable or Disable parameters writing via modbus
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::read_ParametersReadonly(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::read_ParametersReadonly(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::read_ParametersReadonly) ENABLED START -----*/

	(*attr_ParametersReadonly_read) = modbus_read_coil(COIL_OFFSET + ENABLE_WRITING_ADDR);
	//	Set the attribute value
	attr.set_value(attr_ParametersReadonly_read);

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::read_ParametersReadonly
}

//--------------------------------------------------------
/**
 *	Write ParametersReadonly attribute values to hardware.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::write_ParametersReadonly(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::write_ParametersReadonly(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Omega_CN7::write_ParametersReadonly) ENABLED START -----*/

	modbus_write_coil(COIL_OFFSET + ENABLE_WRITING_ADDR, w_val);
	

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::write_ParametersReadonly
}

//--------------------------------------------------------
/**
 *	Read SetPoint attribute
 *	Description: Temperature set point, unit is C or F.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::read_SetPoint(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::read_SetPoint(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::read_SetPoint) ENABLED START -----*/

	// Remember that SetPoint unit on the instrument is 0.1 (C or F)
	(*attr_SetPoint_read) = 0.1 * modbus_read_register(REGISTER_OFFSET + SET_POINT_ADDR);
	//	Set the attribute value
	attr.set_value(attr_SetPoint_read);
	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::read_SetPoint
}

//--------------------------------------------------------
/**
 *	Write SetPoint attribute values to hardware.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::write_SetPoint(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::write_SetPoint(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Omega_CN7::write_SetPoint) ENABLED START -----*/

	// Remember that SetPoint unit on the instrument is 0.1 (C or F)
	modbus_write_register(REGISTER_OFFSET + SET_POINT_ADDR, (int) (w_val * 10));	

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::write_SetPoint
}

//--------------------------------------------------------
/**
 *	Read Temp_Upper_Limit attribute
 *	Description: The data content should not be higher than the temperature range
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::read_Temp_Upper_Limit(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::read_Temp_Upper_Limit(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::read_Temp_Upper_Limit) ENABLED START -----*/

	(*attr_Temp_Upper_Limit_read) = modbus_read_register(REGISTER_OFFSET + UPPER_LIMIT_TEMP_ADDR);
	//	Set the attribute value
	attr.set_value(attr_Temp_Upper_Limit_read);

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::read_Temp_Upper_Limit
}

//--------------------------------------------------------
/**
 *	Write Temp_Upper_Limit attribute values to hardware.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::write_Temp_Upper_Limit(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::write_Temp_Upper_Limit(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Omega_CN7::write_Temp_Upper_Limit) ENABLED START -----*/

	modbus_write_register(REGISTER_OFFSET + UPPER_LIMIT_TEMP_ADDR, (int) (w_val));	
	

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::write_Temp_Upper_Limit
}

//--------------------------------------------------------
/**
 *	Read Temp_Lower_Limit attribute
 *	Description: The data content should not be lower than the temperature range
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::read_Temp_Lower_Limit(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::read_Temp_Lower_Limit(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::read_Temp_Lower_Limit) ENABLED START -----*/

	(*attr_Temp_Lower_Limit_read) = modbus_read_register(REGISTER_OFFSET + LOWER_LIMIT_TEMP_ADDR);
	//	Set the attribute value
	attr.set_value(attr_Temp_Lower_Limit_read);

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::read_Temp_Lower_Limit
}

//--------------------------------------------------------
/**
 *	Write Temp_Lower_Limit attribute values to hardware.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::write_Temp_Lower_Limit(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::write_Temp_Lower_Limit(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Omega_CN7::write_Temp_Lower_Limit) ENABLED START -----*/

	modbus_write_register(REGISTER_OFFSET + LOWER_LIMIT_TEMP_ADDR, (int) (w_val));	
	

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::write_Temp_Lower_Limit
}

//--------------------------------------------------------
/**
 *	Read SensorType attribute
 *	Description: Please refer to the manual: contents of the ?Temperature Sensor Type and Temperature Range? for detail
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::read_SensorType(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::read_SensorType(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::read_SensorType) ENABLED START -----*/
	(*attr_SensorType_read) = modbus_read_register(REGISTER_OFFSET + SENSOR_TYPE_ADDR);

	//	Set the attribute value
	attr.set_value(attr_SensorType_read);

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::read_SensorType
}

//--------------------------------------------------------
/**
 *	Write SensorType attribute values to hardware.
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::write_SensorType(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::write_SensorType(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Omega_CN7::write_SensorType) ENABLED START -----*/

	modbus_write_register(REGISTER_OFFSET + SENSOR_TYPE_ADDR, (int) (w_val));	
	

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::write_SensorType
}

//--------------------------------------------------------
/**
 *	Read Control_method attribute
 *	Description: 0: PID, 1: ON/OFF, 2: manual tuning, 3: PID grogram control
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::read_Control_method(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::read_Control_method(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::read_Control_method) ENABLED START -----*/
	(*attr_Control_method_read) = modbus_read_register(REGISTER_OFFSET + CONTROL_METHOD_ADDR);

	//	Set the attribute value
	attr.set_value(attr_Control_method_read);

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::read_Control_method
}

//--------------------------------------------------------
/**
 *	Write Control_method attribute values to hardware.
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::write_Control_method(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::write_Control_method(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Omega_CN7::write_Control_method) ENABLED START -----*/
	modbus_write_register(REGISTER_OFFSET + CONTROL_METHOD_ADDR, (int) (w_val));	
	
	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::write_Control_method
}

//--------------------------------------------------------
/**
 *	Read Heating_Cooling_Control attribute
 *	Description: 0: Heating, 1: Cooling, 2: Heating/Cooling, 3: Cooling/Heating
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::read_Heating_Cooling_Control(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::read_Heating_Cooling_Control(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::read_Heating_Cooling_Control) ENABLED START -----*/
	(*attr_Heating_Cooling_Control_read) = modbus_read_register(REGISTER_OFFSET + HEATING_COOLING_CTRL_ADDR);

	//	Set the attribute value
	attr.set_value(attr_Heating_Cooling_Control_read);

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::read_Heating_Cooling_Control
}

//--------------------------------------------------------
/**
 *	Write Heating_Cooling_Control attribute values to hardware.
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::write_Heating_Cooling_Control(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::write_Heating_Cooling_Control(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Omega_CN7::write_Heating_Cooling_Control) ENABLED START -----*/
	modbus_write_register(REGISTER_OFFSET + HEATING_COOLING_CTRL_ADDR, (int) (w_val));	

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::write_Heating_Cooling_Control
}

//--------------------------------------------------------
/**
 *	Read TemperatureValue attribute
 *	Description: Measuring unit is C or F, updated one time in 0.4 second
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::read_TemperatureValue(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::read_TemperatureValue(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::read_TemperatureValue) ENABLED START -----*/
	(*attr_TemperatureValue_read) = 0.1 * modbus_read_register(REGISTER_OFFSET + PROCESS_VALUE_ADDR);

	//	Set the attribute value
	attr.set_value(attr_TemperatureValue_read);

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::read_TemperatureValue
}
//--------------------------------------------------------
/**
 *	Read Temperature_Unit attribute
 *	Description: C/linear input (default): 1 , F : 0
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::read_Temperature_Unit(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::read_Temperature_Unit(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::read_Temperature_Unit) ENABLED START -----*/

	(*attr_Temperature_Unit_read) = modbus_read_coil(COIL_OFFSET + TEMP_UNIT_ADDR);
	//	Set the attribute value
	attr.set_value(attr_Temperature_Unit_read);

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::read_Temperature_Unit
}

//--------------------------------------------------------
/**
 *	Write Temperature_Unit attribute values to hardware.
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::write_Temperature_Unit(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::write_Temperature_Unit(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Omega_CN7::write_Temperature_Unit) ENABLED START -----*/

	modbus_write_coil(COIL_OFFSET + TEMP_UNIT_ADDR, w_val);

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::write_Temperature_Unit
}

//--------------------------------------------------------
/**
 *	Read Led_Status attribute
 *	Description: b0: Alm3, b1: Alm2, b2: F, b3:?, b4: Alm1, b5: OUT2, b6: OUT1, b7: AT
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Omega_CN7::read_Led_Status(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Omega_CN7::read_Led_Status(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Omega_CN7::read_Led_Status) ENABLED START -----*/

	(*attr_Led_Status_read) = modbus_read_register(REGISTER_OFFSET + LED_STATUS_ADDR);
	//	Set the attribute value
	attr.set_value(attr_Led_Status_read);

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::read_Led_Status
}

//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::Omega_CN7Class::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *	              for specified device.
 */
//--------------------------------------------------------
void Omega_CN7::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Omega_CN7::Class::add_dynamic_attributes) ENABLED START -----*/

	//	Add your own code to create and add dynamic attributes if any

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::add_dynamic_attributes

}



//========================================================
//	Command execution methods
//========================================================


	/*----- PROTECTED REGION ID(Omega_CN7::namespace_ending) ENABLED START -----*/

	//	Additional Methods

void Omega_CN7::close_connection(Tango::DeviceProxy *devproxy_in)
{
	delete devproxy_in;
	devproxy_in = NULL;
}

bool Omega_CN7::check_connection(Tango::DeviceProxy *devproxy_in)
{
	if (devproxy_in == NULL)
		return false;

	try
	{
		devproxy_in->ping();
		set_state(Tango::ON);
		set_status("The device is in ON state.");
		return true;
	}
	catch(...)
	{
		set_state(Tango::FAULT);
		set_status("Modbus device not responding.");
		return false;
	}
}

bool Omega_CN7::get_modbus_connection()
{
	// if we already have a serial device instance, do nothing
	if (check_connection(modbus_device))
		return true;

	// otherwise, try to (re)connect
	try
	{
		// connect
		modbus_device = new Tango::DeviceProxy(modbus_devicename.c_str());

		// if we could not connect, notify caller
		if (!check_connection(modbus_device))
			return false;

		// everything is ok
		return true;

	}
	catch(...)
	{
		// if anything goes wrong, free the serial device and return false
		close_connection(modbus_device);

		return false;
	}
}


int Omega_CN7::modbus_read_register(short address) {
	int res=-1;
	DEBUG_STREAM << "Omega_CN7::modbus_read_register("<< address<<"): entering... !" << endl;
	//	Add your own code to control device here
	const Tango::DevVarShortArray *vlarr;
	short no_registers;
	Tango::DevVarShortArray modbus_registers;

	if (!get_modbus_connection()) {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"Modbus device communication ERROR",
			   (const char *)"Omega_CN7::modbus_read_register");
	}
	no_registers = 1;
	modbus_registers.length(2);
	modbus_registers[0] = address;
	modbus_registers[1] = no_registers;
	try
	{
		Tango::DeviceData argin;
		argin << modbus_registers;
		Tango::DeviceData out = modbus_device->command_inout("ReadHoldingRegisters",argin);

		out >> vlarr;
		if (vlarr->length() != no_registers) {
	    		Tango::Except::throw_exception(
				   (const char *)"Omega_CN7",
				   (const char *)"Wrong number of register in MODBUS reply",
				   (const char *)"Omega_CN7::modbus_read_register");
  		}
		for (int i=0; i < vlarr->length(); i++)  // Copy received data to argout
		  res = (int)(*vlarr)[i] ;

	}
	catch (CORBA::Exception &e)
        {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"MODBUS device communication error",
			   (const char *)"Omega_CN7::modbus_read_register");
        }
        catch (...)
        {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"MODBUS device communication error",
			   (const char *)"Omega_CN7::modbus_read_register");
        }

	return res;
}


void Omega_CN7::modbus_write_register(short address, int value) {
	int res=-1;
	DEBUG_STREAM << "Omega_CN7::modbus_write_register(): entering... !" << endl;
	const Tango::DevVarShortArray *vlarr;
	short no_registers;
	Tango::DevVarShortArray modbus_registers;

	if (!get_modbus_connection()) {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"Modbus device communication ERROR",
			   (const char *)"Omega_CN7::modbus_write_register");
	}

	no_registers = 1;
	modbus_registers.length(2);
	modbus_registers[0] = address;
	modbus_registers[1] = value;
	try
	{
		Tango::DeviceData argin;
		argin << modbus_registers;
		modbus_device->command_inout("PresetSingleregister",argin);
	}
	catch (CORBA::Exception &e)
        {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"MODBUS device communication error",
			   (const char *)"Omega_CN7::modbus_write_register");
        }
        catch (...)
        {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"MODBUS device communication error",
			   (const char *)"Omega_CN7::modbus_write_register");
        }
}


int Omega_CN7::modbus_read_coil(short address) {
	Tango::DevShort res = -1;
	DEBUG_STREAM << "Omega_CN7::modbus_read_coil("<< address<<"): entering... !" << endl;
	//	Add your own code to control device here
	if (!get_modbus_connection()) {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"Modbus device communication ERROR",
			   (const char *)"Omega_CN7::modbus_read_coil");
	}

	try
	{
		Tango::DeviceData argin;
		argin << address;
		Tango::DeviceData out = modbus_device->command_inout("ReadCoilStatus",argin);

		out >> res;

	}
	catch (CORBA::Exception &e)
        {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"MODBUS device communication error",
			   (const char *)"Omega_CN7::modbus_read_coil");
        }
        catch (...)
        {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"MODBUS device communication error",
			   (const char *)"Omega_CN7::modbus_read_coil");
        }

	return (int)res;
}


void Omega_CN7::modbus_write_coil(short address, int value) {
	int res=-1;
	DEBUG_STREAM << "Omega_CN7::modbus_write_coil(): entering... !" << endl;
	//	Add your own code to control device here
	if (!get_modbus_connection()) {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"Modbus device communication ERROR",
			   (const char *)"Omega_CN7::modbus_write_coil");
	}
	short no_coils;
	Tango::DevVarShortArray modbus_coils;

	no_coils = 1;
	modbus_coils.length(2);
	modbus_coils[0] = address;
	modbus_coils[1] = value;
	try
	{
		Tango::DeviceData argin;
		argin << modbus_coils;
		modbus_device->command_inout("ForceSingleCoil",argin);
	}
	catch (CORBA::Exception &e)
        {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"MODBUS device communication error",
			   (const char *)"Omega_CN7::modbus_write_coil");
        }
        catch (...)
        {
	    	Tango::Except::throw_exception(
			   (const char *)"Omega_CN7",
			   (const char *)"MODBUS device communication error",
			   (const char *)"Omega_CN7::modbus_write_coil");
        }
}


	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::namespace_ending
} //	namespace
