/*----- PROTECTED REGION ID(Omega_CN7Class.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: Omega_CN7Class.cpp,v 1.1.1.1 2013-12-24 14:51:55 borghes Exp $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/omegacn7x/src/Omega_CN7Class.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Omega_CN7Class.cpp
//
// description : C++ source for the Omega_CN7Class. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the name once per process.
//
// project :     OMEGA CN7 series temperature/process controller.
//
// $Author: borghes $
//
// $Revision: 1.1.1.1 $
// $Date: 2013-12-24 14:51:55 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/omegacn7x/src/Omega_CN7Class.cpp,v $
// $Log: Omega_CN7Class.cpp,v $
// Revision 1.1.1.1  2013-12-24 14:51:55  borghes
// OMEGA CN7x Device Server
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Omega_CN7Class.h>

/*----- PROTECTED REGION END -----*/

//-------------------------------------------------------------------
/**
 *	Create Omega_CN7Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Omega_CN7_class(const char *name) {
		return Omega_CN7_ns::Omega_CN7Class::init(name);
	}
}


namespace Omega_CN7_ns
{


//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Omega_CN7Class *Omega_CN7Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Omega_CN7Class::Omega_CN7Class(string &s)
 * description : 	constructor for the Omega_CN7Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Omega_CN7Class::Omega_CN7Class(string &s):DeviceClass(s)
{
	cout2 << "Entering Omega_CN7Class constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Omega_CN7::Class::constructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::constructor

	cout2 << "Leaving Omega_CN7Class constructor" << endl;
}


//--------------------------------------------------------
/**
 * method : 		Omega_CN7Class::~Omega_CN7Class()
 * description : 	destructor for the Omega_CN7Class
 */
//--------------------------------------------------------
Omega_CN7Class::~Omega_CN7Class()
{
	/*----- PROTECTED REGION ID(Omega_CN7::Class::destructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Omega_CN7Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Omega_CN7Class *Omega_CN7Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Omega_CN7Class(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Omega_CN7Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Omega_CN7Class *Omega_CN7Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}




//===================================================================
//	Command execution method calls
//===================================================================




//===================================================================
//	Properties management
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Omega_CN7Class::get_class_property
 * description : 	Get the class property for specified name.
 *
 * @param	name  The property name
 */
//--------------------------------------------------------
Tango::DbDatum Omega_CN7Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::Omega_CN7Class::get_default_device_property()()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Omega_CN7Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::Omega_CN7Class::get_default_class_property()()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Omega_CN7Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::Omega_CN7Class::get_class_property()
 *	Description : //	Add your own code to initialize
 */
//--------------------------------------------------------
void Omega_CN7Class::get_class_property()
{
}


//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::Omega_CN7Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *	              For each property, add to wizard property name and description.
 *	              If default value has been set, add it to wizard property and.
 *	              store it in a DbDatum.
 */
//--------------------------------------------------------
void Omega_CN7Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;
	
	//	Set Default Class Properties

	//	Set Default Device Properties

	prop_name = "Modbus_devicename";
	prop_desc = "TANGO Modbus communication device name";
	prop_def  = "test/ldm/cn7600/PresetSingleRegister\n";
	vect_data.clear();
	vect_data.push_back("test/ldm/cn7600/PresetSingleRegister");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}


//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::Omega_CN7Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Omega_CN7Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("OMEGA CN7 series temperature/process controller");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("OMEGA CN7200, CN7500, CN7600, CN7800 Series");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs or svn location
	string	filename("Omega_CN7");
	filename += "Class.cpp";
	
	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}
	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}




//===================================================================
//	Factory methods
//===================================================================


//--------------------------------------------------------
/**
 * method : 		Omega_CN7Class::device_factory
 * description : 	Create the device object(s)
 *                  and store them in the device list
 *
 * @param	*devlist_ptr	The device name list
 */
//--------------------------------------------------------
void Omega_CN7Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	/*----- PROTECTED REGION ID(Omega_CN7::Class::device_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Omega_CN7(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Omega_CN7 *dev = static_cast<Omega_CN7 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Omega_CN7::Class::device_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::device_factory_after

	
}


//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::Omega_CN7Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *	              and store them in the attribute list
 */
//--------------------------------------------------------
void Omega_CN7Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Omega_CN7::Class::attribute_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::attribute_factory_before


	//	Attribute : ParametersReadonly
	ParametersReadonlyAttrib	*parametersreadonly = new ParametersReadonlyAttrib();
	Tango::UserDefaultAttrProp	parametersreadonly_prop;
	parametersreadonly_prop.set_description("Enable or Disable parameters writing via modbus");
	//	label	not set for	ParametersReadonly
	//	unit	not set for	ParametersReadonly
	//	standard_unit	not set for	ParametersReadonly
	//	display_unit	not set for	ParametersReadonly
	//	format	not set for	ParametersReadonly
	//	max_value	not set for	ParametersReadonly
	//	min_value	not set for	ParametersReadonly
	//	max_alarm	not set for	ParametersReadonly
	//	min_alarm	not set for	ParametersReadonly
	//	max_warning	not set for	ParametersReadonly
	//	min_warning	not set for	ParametersReadonly
	//	delta_t	not set for	ParametersReadonly
	//	delta_val	not set for	ParametersReadonly
	parametersreadonly->set_default_properties(parametersreadonly_prop);
	//	Not Polled
	parametersreadonly->set_disp_level(Tango::OPERATOR);
	parametersreadonly->set_memorized();
	parametersreadonly->set_memorized_init(true);
	//	ParametersReadonly does not fire change event
	//	ParametersReadonly does not fire archive event
	//	ParametersReadonly does not fire data_ready event
	att_list.push_back(parametersreadonly);

	//	Attribute : SetPoint
	SetPointAttrib	*setpoint = new SetPointAttrib();
	Tango::UserDefaultAttrProp	setpoint_prop;
	setpoint_prop.set_description("Temperature set point, unit is C or F.");
	//	label	not set for	SetPoint
	//	unit	not set for	SetPoint
	//	standard_unit	not set for	SetPoint
	//	display_unit	not set for	SetPoint
	//	format	not set for	SetPoint
	//	max_value	not set for	SetPoint
	//	min_value	not set for	SetPoint
	//	max_alarm	not set for	SetPoint
	//	min_alarm	not set for	SetPoint
	//	max_warning	not set for	SetPoint
	//	min_warning	not set for	SetPoint
	//	delta_t	not set for	SetPoint
	//	delta_val	not set for	SetPoint
	setpoint->set_default_properties(setpoint_prop);
	//	Not Polled
	setpoint->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	SetPoint does not fire change event
	//	SetPoint does not fire archive event
	//	SetPoint does not fire data_ready event
	att_list.push_back(setpoint);

	//	Attribute : Temp_Upper_Limit
	Temp_Upper_LimitAttrib	*temp_upper_limit = new Temp_Upper_LimitAttrib();
	Tango::UserDefaultAttrProp	temp_upper_limit_prop;
	temp_upper_limit_prop.set_description("The data content should not be higher than the temperature range");
	//	label	not set for	Temp_Upper_Limit
	//	unit	not set for	Temp_Upper_Limit
	//	standard_unit	not set for	Temp_Upper_Limit
	//	display_unit	not set for	Temp_Upper_Limit
	//	format	not set for	Temp_Upper_Limit
	//	max_value	not set for	Temp_Upper_Limit
	//	min_value	not set for	Temp_Upper_Limit
	//	max_alarm	not set for	Temp_Upper_Limit
	//	min_alarm	not set for	Temp_Upper_Limit
	//	max_warning	not set for	Temp_Upper_Limit
	//	min_warning	not set for	Temp_Upper_Limit
	//	delta_t	not set for	Temp_Upper_Limit
	//	delta_val	not set for	Temp_Upper_Limit
	temp_upper_limit->set_default_properties(temp_upper_limit_prop);
	//	Not Polled
	temp_upper_limit->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Temp_Upper_Limit does not fire change event
	//	Temp_Upper_Limit does not fire archive event
	//	Temp_Upper_Limit does not fire data_ready event
	att_list.push_back(temp_upper_limit);

	//	Attribute : Temp_Lower_Limit
	Temp_Lower_LimitAttrib	*temp_lower_limit = new Temp_Lower_LimitAttrib();
	Tango::UserDefaultAttrProp	temp_lower_limit_prop;
	temp_lower_limit_prop.set_description("The data content should not be lower than the temperature range");
	//	label	not set for	Temp_Lower_Limit
	//	unit	not set for	Temp_Lower_Limit
	//	standard_unit	not set for	Temp_Lower_Limit
	//	display_unit	not set for	Temp_Lower_Limit
	//	format	not set for	Temp_Lower_Limit
	//	max_value	not set for	Temp_Lower_Limit
	//	min_value	not set for	Temp_Lower_Limit
	//	max_alarm	not set for	Temp_Lower_Limit
	//	min_alarm	not set for	Temp_Lower_Limit
	//	max_warning	not set for	Temp_Lower_Limit
	//	min_warning	not set for	Temp_Lower_Limit
	//	delta_t	not set for	Temp_Lower_Limit
	//	delta_val	not set for	Temp_Lower_Limit
	temp_lower_limit->set_default_properties(temp_lower_limit_prop);
	//	Not Polled
	temp_lower_limit->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Temp_Lower_Limit does not fire change event
	//	Temp_Lower_Limit does not fire archive event
	//	Temp_Lower_Limit does not fire data_ready event
	att_list.push_back(temp_lower_limit);

	//	Attribute : SensorType
	SensorTypeAttrib	*sensortype = new SensorTypeAttrib();
	Tango::UserDefaultAttrProp	sensortype_prop;
	sensortype_prop.set_description("Please refer to the manual: contents of the ?Temperature Sensor Type and Temperature Range? for detail");
	//	label	not set for	SensorType
	//	unit	not set for	SensorType
	//	standard_unit	not set for	SensorType
	//	display_unit	not set for	SensorType
	//	format	not set for	SensorType
	sensortype_prop.set_max_value("17");
	sensortype_prop.set_min_value("0");
	//	max_alarm	not set for	SensorType
	//	min_alarm	not set for	SensorType
	//	max_warning	not set for	SensorType
	//	min_warning	not set for	SensorType
	//	delta_t	not set for	SensorType
	//	delta_val	not set for	SensorType
	sensortype->set_default_properties(sensortype_prop);
	//	Not Polled
	sensortype->set_disp_level(Tango::OPERATOR);
	sensortype->set_memorized();
	sensortype->set_memorized_init(true);
	//	SensorType does not fire change event
	//	SensorType does not fire archive event
	//	SensorType does not fire data_ready event
	att_list.push_back(sensortype);

	//	Attribute : Control_method
	Control_methodAttrib	*control_method = new Control_methodAttrib();
	Tango::UserDefaultAttrProp	control_method_prop;
	control_method_prop.set_description("0: PID, 1: ON/OFF, 2: manual tuning, 3: PID grogram control");
	//	label	not set for	Control_method
	//	unit	not set for	Control_method
	//	standard_unit	not set for	Control_method
	//	display_unit	not set for	Control_method
	//	format	not set for	Control_method
	control_method_prop.set_max_value("3");
	control_method_prop.set_min_value("0");
	//	max_alarm	not set for	Control_method
	//	min_alarm	not set for	Control_method
	//	max_warning	not set for	Control_method
	//	min_warning	not set for	Control_method
	//	delta_t	not set for	Control_method
	//	delta_val	not set for	Control_method
	control_method->set_default_properties(control_method_prop);
	//	Not Polled
	control_method->set_disp_level(Tango::OPERATOR);
	control_method->set_memorized();
	control_method->set_memorized_init(true);
	//	Control_method does not fire change event
	//	Control_method does not fire archive event
	//	Control_method does not fire data_ready event
	att_list.push_back(control_method);

	//	Attribute : Heating_Cooling_Control
	Heating_Cooling_ControlAttrib	*heating_cooling_control = new Heating_Cooling_ControlAttrib();
	Tango::UserDefaultAttrProp	heating_cooling_control_prop;
	heating_cooling_control_prop.set_description("0: Heating, 1: Cooling, 2: Heating/Cooling, 3: Cooling/Heating");
	//	label	not set for	Heating_Cooling_Control
	//	unit	not set for	Heating_Cooling_Control
	//	standard_unit	not set for	Heating_Cooling_Control
	//	display_unit	not set for	Heating_Cooling_Control
	//	format	not set for	Heating_Cooling_Control
	heating_cooling_control_prop.set_max_value("3");
	heating_cooling_control_prop.set_min_value("0");
	//	max_alarm	not set for	Heating_Cooling_Control
	//	min_alarm	not set for	Heating_Cooling_Control
	//	max_warning	not set for	Heating_Cooling_Control
	//	min_warning	not set for	Heating_Cooling_Control
	//	delta_t	not set for	Heating_Cooling_Control
	//	delta_val	not set for	Heating_Cooling_Control
	heating_cooling_control->set_default_properties(heating_cooling_control_prop);
	//	Not Polled
	heating_cooling_control->set_disp_level(Tango::OPERATOR);
	heating_cooling_control->set_memorized();
	heating_cooling_control->set_memorized_init(true);
	//	Heating_Cooling_Control does not fire change event
	//	Heating_Cooling_Control does not fire archive event
	//	Heating_Cooling_Control does not fire data_ready event
	att_list.push_back(heating_cooling_control);

	//	Attribute : TemperatureValue
	TemperatureValueAttrib	*temperaturevalue = new TemperatureValueAttrib();
	Tango::UserDefaultAttrProp	temperaturevalue_prop;
	temperaturevalue_prop.set_description("Measuring unit is C or F, updated one time in 0.4 second");
	//	label	not set for	TemperatureValue
	//	unit	not set for	TemperatureValue
	//	standard_unit	not set for	TemperatureValue
	//	display_unit	not set for	TemperatureValue
	//	format	not set for	TemperatureValue
	//	max_value	not set for	TemperatureValue
	//	min_value	not set for	TemperatureValue
	//	max_alarm	not set for	TemperatureValue
	//	min_alarm	not set for	TemperatureValue
	//	max_warning	not set for	TemperatureValue
	//	min_warning	not set for	TemperatureValue
	//	delta_t	not set for	TemperatureValue
	//	delta_val	not set for	TemperatureValue
	temperaturevalue->set_default_properties(temperaturevalue_prop);
	//	Not Polled
	temperaturevalue->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	TemperatureValue does not fire change event
	//	TemperatureValue does not fire archive event
	//	TemperatureValue does not fire data_ready event
	att_list.push_back(temperaturevalue);

	//	Attribute : Temperature_Unit
	Temperature_UnitAttrib	*temperature_unit = new Temperature_UnitAttrib();
	Tango::UserDefaultAttrProp	temperature_unit_prop;
	temperature_unit_prop.set_description("C/linear input (default): 1 , F : 0");
	//	label	not set for	Temperature_Unit
	//	unit	not set for	Temperature_Unit
	//	standard_unit	not set for	Temperature_Unit
	//	display_unit	not set for	Temperature_Unit
	//	format	not set for	Temperature_Unit
	temperature_unit_prop.set_max_value("1");
	temperature_unit_prop.set_min_value("0");
	//	max_alarm	not set for	Temperature_Unit
	//	min_alarm	not set for	Temperature_Unit
	//	max_warning	not set for	Temperature_Unit
	//	min_warning	not set for	Temperature_Unit
	//	delta_t	not set for	Temperature_Unit
	//	delta_val	not set for	Temperature_Unit
	temperature_unit->set_default_properties(temperature_unit_prop);
	//	Not Polled
	temperature_unit->set_disp_level(Tango::OPERATOR);
	temperature_unit->set_memorized();
	temperature_unit->set_memorized_init(true);
	//	Temperature_Unit does not fire change event
	//	Temperature_Unit does not fire archive event
	//	Temperature_Unit does not fire data_ready event
	att_list.push_back(temperature_unit);

	//	Attribute : Led_Status
	Led_StatusAttrib	*led_status = new Led_StatusAttrib();
	Tango::UserDefaultAttrProp	led_status_prop;
	led_status_prop.set_description("b0: Alm3, b1: Alm2, b2: F, b3:?, b4: Alm1, b5: OUT2, b6: OUT1, b7: AT");
	//	label	not set for	Led_Status
	//	unit	not set for	Led_Status
	//	standard_unit	not set for	Led_Status
	//	display_unit	not set for	Led_Status
	//	format	not set for	Led_Status
	//	max_value	not set for	Led_Status
	//	min_value	not set for	Led_Status
	//	max_alarm	not set for	Led_Status
	//	min_alarm	not set for	Led_Status
	//	max_warning	not set for	Led_Status
	//	min_warning	not set for	Led_Status
	//	delta_t	not set for	Led_Status
	//	delta_val	not set for	Led_Status
	led_status->set_default_properties(led_status_prop);
	//	Not Polled
	led_status->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Led_Status does not fire change event
	//	Led_Status does not fire archive event
	//	Led_Status does not fire data_ready event
	att_list.push_back(led_status);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());

	/*----- PROTECTED REGION ID(Omega_CN7::Class::attribute_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::attribute_factory_after

}


//--------------------------------------------------------
/**
 *	Method      : Omega_CN7::Omega_CN7Class::command_factory()
 *	Description : Create the command object(s)
 *	              and store them in the command list
 */
//--------------------------------------------------------
void Omega_CN7Class::command_factory()
{
	/*----- PROTECTED REGION ID(Omega_CN7::Class::command_factory_before) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::command_factory_before


	/*----- PROTECTED REGION ID(Omega_CN7::Class::command_factory_after) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::command_factory_after

}




//===================================================================
//	Dynamic attributes related methods
//===================================================================


//--------------------------------------------------------
/**
 * method : 		Omega_CN7Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void Omega_CN7Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;


	/*----- PROTECTED REGION ID(Omega_CN7::Class::create_static_att_list) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::create_static_att_list

}


//--------------------------------------------------------
/**
 * method : 		Omega_CN7Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Omega_CN7Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Omega_CN7 *dev = static_cast<Omega_CN7 *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()],true);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Omega_CN7::Class::erase_dynamic_attributes) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::erase_dynamic_attributes

}



	/*----- PROTECTED REGION ID(Omega_CN7::Class::Additional Methods) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Omega_CN7::Class::Additional Methods

} //	namespace
